public int findIndex(int[] array, int v) {
  int index= -1;
  for (int i=0; i<numCols; i++) {
    if (array[i] == v) index = i;
  }
  if (D&&V) println("found " + v + " at index " + index);
  return index;
}

public int findIndex2(int[] array, Integer v) {
  int index= -1;
  for (int i=0; i<numCols; i++) {
    if (array[i] == v) index = i;
  }
  if (D&&V) println("found " + v + " at index " + index);
  return index;
}

public void sortThis(Subclass[] d) {
  boolean go = true;
  int j = 0;
  Subclass tmp;

  while (go) {
    go = false;
    for (int i=0; i< d.length - 1; i++) {
      if (d[i].rank[0] > d[i+1].rank[0]) {
        tmp = new Subclass(d[i]);
        d[i] = d[i+1];
        d[i+1] = tmp;
        go = true;
      }
    }
  }
}


public void paintSubclassHeader(Subclass sc, int x, int y, String side) {
  fill(WHITE);  
  if (side == "left")      rect(0, y, width/2, boxH);
  else if (side == "right") rect(width/2+gutter-pad, y, width/2, boxH);

  fill(BLACK);
  textSize(12);
  text(sc.lowBound + " - " + sc.highBound, x, y - boxH*2 );
  textSize(15);
  text(sc.name, x, y + boxH );
  textSize(10);
}

public void paintSortedDataFocus( Subclass sc, int x, int y ) {
  fill(BLACK);
  textAlign(LEFT);
  textSize(12);

  int flip = 0;
  int sum=0;
  for (int u=0; u<7; u++) sum += sc.rank[u];
  if (m_rightHalf && mouseY > height - 222) flip = - column;
  else if (m_leftHalf && ( y+column+gutter >= height) ) flip = - column;
  else flip=0;

  text(sum + " total checkouts", x, y+gutter*0 +flip);
  text(sc.rank[0] + " lowest day count", x, y+gutter*1 +flip);
  text(sc.rank[6] + " highest day count", x, y+gutter*2 +flip);
  text(sum/52 + " avg checkouts/week", x, y+gutter*3 +flip);      
  text(sum/365 + " avg checkouts/day", x, y+gutter*4 +flip);              
  textSize(10);
}

public void paintUnorgHeader(int x, int y) {
  fill(BLACK);
  textAlign(CENTER);
  text("S", x, y);
  text("M", x+(boxW*1+pad), y);
  text("T", x+(boxW*2+pad), y);
  text("W", x+(boxW*3+pad*2), y);
  text("R", x+(boxW*4+pad*3), y);
  text("F", x+(boxW*5+pad*4), y);
  text("S", x+(boxW*6+pad*5), y); 
  textAlign(LEFT);
}

public void paintOrgHeader(String s, int x, int y) {
  fill(BLACK);
  textAlign(CENTER);
  text(s, x, y);
  textAlign(LEFT);
}

void deweyNums() {
  fill(BLACK);
  textAlign(LEFT, BOTTOM);
  textSize(10);

  for (int i=0; i< catData.length; i++) {
    text(catData[i].lowBound, column-gutter, (boxH*(i*10+1))+gutter+2);
    text(catData[i].name, column, (boxH*(i*10+1))+gutter+2);
  } 
  text("dewey decimal categories", column-gutter, (boxH)*99+gutter);
}

void title() {
  fill(BLACK);
  textSize(15);
  textAlign(RIGHT);
  text("POPULAR DAYS OF THE WEEK", (column*6-gutter), (column*3.5));
  textSize(22);
  fill(92);
  text("for book checkouts", (column*6-gutter), (column*3.5)+22);
}

void setup() {
  size(column*6, 800);
  background(255);
  smooth();
  textSize(10);

  tableT = new Table();
  tableT = loadTable("dewey_classes.csv", "header");
  nR = tableT.getRowCount(); 
  nC = tableT.getColumnCount();

  for ( int j = 0; j<catData.length; j++) {
    catData[j] = new Catclass( tableT.getString(j, 1), j );
  }

  for (int y=0; y< 10; y++ ) {
    println(catData[y].name);
  }

  tableT = loadTable("dewey_subclasses.csv", "header");
  nR = tableT.getRowCount(); 
  nC = tableT.getColumnCount();
  subclassMatrix = new String[nR][nC];
  for ( int i = 0; i< nR; i++) {
    for ( int j = 0; j< nC; j++) {
      subclassMatrix[i][j] = tableT.getString(i, j);
      if (VV) print( subclassMatrix[i][j] + " ");
    }
    if (VV) println(",");
  }

  int category=0;
  for (int k=0; k<99; k++ ) {
    data[k] = new Subclass(subclassMatrix[k][1], category, k*10);
    sortedData[k] = new Subclass(subclassMatrix[k][1], category, k*10);
    if (k%10 == 9 ) category++;
    if (V) data[k].printSelf();
  }

  table1 = new Table();
  table1 = loadTable("weekday_cout_2010_by10s_books.csv", "header"); 
  numRows = table1.getRowCount(); 
  numCols = table1.getColumnCount();
  if (VV) println("Rows: " + numRows + "  Cols: " + numCols);

  for ( int i = 0; i< numRows; i++) {
    for ( int j = 0; j< numCols; j++) {
      data[i].addWeekday(shortWd[j], table1.getInt(i, j), j); 
      sortedData[i].addWeekday(shortWd[j], table1.getInt(i, j), j);
    }
    data[i].sortWeek();
    sortedData[i].sortWeek();
  }  

  sortThis(sortedData);

  //for(int f=0; f<sortedData.length; f++) sortedData[f].printSelf();
}



void draw() {
  background(SOFTWHITE);
  noStroke();

  paintUnorgHeader((column*2)+(boxW/2+pad), boxW);
  paintUnorgHeader((column*2)+(boxW/2+pad), boxH*100 +gutter+pad);
  paintOrgHeader("LOW CHECKOUT COUNT", column*3 +column/2 +gutter, boxW);
  paintOrgHeader("HIGH CHECKOUT COUNT", column*3 + column/2 +gutter, boxH*100 + gutter+pad);

  deweyNums();
  //if (mouseX <= width/2) title();
  fill(0);
  textSize(10);

  if ( mouseX < width/2 ) {
    m_leftHalf = true;
    m_rightHalf = false;
  } else {
    m_leftHalf = false;
    m_rightHalf = true;
  }

  int i, j, h, tmp;

  for (i = 0; i < numRows; i++) { 

    if ( m_leftHalf && mouseY >=  boxH*i+gutter && mouseY < boxH*(i+1)+(gutter)) {
      textAlign(RIGHT);
      paintSubclassHeader( data[i], column*2 - pad, i*boxH+gutter, "left" );
      textAlign(LEFT);
      showAll=false;

      activeCategory = data[i].catNum;
      activeSubclass = data[i].lowBound;
    }

    if ( m_rightHalf && mouseY >=  boxH*i+gutter && mouseY < boxH*(i+1)+(gutter)) {
      textAlign(BOTTOM, LEFT);
      paintSubclassHeader(sortedData[i], column*4 + gutter+ pad, i*boxH+gutter, "right" );
      paintSortedDataFocus( sortedData[i], column*4+gutter+gutter, i*boxH +gutter+boxH+gutter );
      showAll=true;
    }

    //PRINT GROUPED BY DEWEY MATRIX
    for (j = 0; j < numCols; j++) {
      tmp = findIndex2( data[i].rank, data[i].getWeekdayVal( shortWd[j] ) );

      fill(120, 155, 56, tmp*30 +35);
      rect(j*(boxW+pad)+(column*2), i*(boxH)+(gutter), boxW, boxH);
    }

    //sortedData[i].printSelf();
    //sortedData[i].printWeek();
    //int[] arr = sortedData[i].rank;
    //int val = sortedData[i].rank[j];
    //tmp = findIndex2( arr, val );  

    if (showAll) {      
      //PRINT THE SORTED MATRIX
      fill(56, 120, 155, sortedData[i].catNum *15 + 100);
      rect( (column*3)+gutter, i*(boxH)+(gutter)+1, (boxW+pad)*7, boxH-1);
    } else if ( sortedData[i].catNum == activeCategory ) {

      if ( sortedData[i].lowBound == activeSubclass ) {
        textAlign(BOTTOM, LEFT);
        paintSubclassHeader( sortedData[i], column*4 + gutter+ pad, i*boxH+gutter, "right" );
        paintSortedDataFocus( sortedData[i], column*4+gutter+gutter, i*boxH +gutter+boxH+gutter );
      }

    //PRINT THE SORTED MATRIX ACTIVE CATEGORY LINES
      fill(56, 120, 155, sortedData[i].catNum *20 +35 );
      rect( (column*3)+gutter, i*(boxH)+(gutter)+1, (boxW+pad)*7, boxH-1);
    }
  } //CLOSES OUTER FOR nR
}

